Attribute VB_Name = "REP"
'*****************************************************************************
'   The parameter structure definition that is used by your application
'   to specify the operation parameters and text data to the 'form' routine.
'   For an example for using this structure, refer to the demo.c file.
'*****************************************************************************

Type TypeForm
       x      As Long    'Initial x position of the editing window,
                             'you may specify CW_USEDEFAULT to use default values.
       y      As Long    'Initial y position of the editing window.
       width  As Long    'Initial width of the window in device units,
                            'you may specify CW_USEDEFAULT to use default values.
       height As Long    'Initial height of the editing window.  When you
                            ' use CW_USEDEFAULT for width, the height parameter is
                            ' ingnored.

       reserved1 As Long    ' Reserved for internal use. Do not modify the
                            ' value in this field


       reserved2 As Long    ' Reserved for internal use. Do do not modify the
                            ' value in this field.

       file As String * 300 ' form file name. If an existing file is specified,
                            ' the following fields are ignored.
                             ' You must append chr(0) to NULL terminate this string

       DataSetName As String * 20 ' (Specify for a new file) Your application can
                             ' specify a data set name which can be used to
                             ' associate the application data to the form.  This
                             ' is an optional field.
                             ' You must append chr(0) to NULL terminate this string

        ShowMenu  As Long  ' show the menu bar
        ShowHorBar As Long ' show the horizonatal scroll bar
        ShowVerBar As Long ' show the vertical scroll bar

        hInst As Long      ' Handle of the current instanaces.
        hPrevInst As Long  ' Handle of the previous instances.
        hParentWnd As Long ' Handle to the parent window
        hFrWnd As Long     ' Form main window handle, will be filled by RE later
        style As Long         ' Editor window style
        FontTypeFace As String * 32 ' Default type face, example: TmwRmn Courier, etc
                              ' You must append chr(0) to NULL terminate this string

        open As Long       ' TRUE indicates an open window (parameter block in use)
        modified As Long   ' TRUE when the file modified, and needs to be saved
        ShowToolbar As Long ' show the toolbar

        MasterDefFile As String * 300  ' master definition file
        DetailDefFile As String * 300  ' detail definition file
        OtherDefFiles As String * 1200 ' other definition files

        DataMapPictFile As String * 300 ' jpeg file which visually shows the data file relationships

End Type


'*****************************************************************************
'   The parameter structure definition that is used by your application
'   to specify the operation parameters to start a report execution session.
'   For an example for using this structure, refer to the demo.c file.
'*****************************************************************************

Type TypeRep
       file   As String * 300 ' form file name
                              ' You must append chr(0) to NULL terminate this field

       device As String * 1   ' P=Printer,S=Screen, F=Native Format File,
                              ' R=Rtf Format File, H=Html File, T=Text file,
                              ' C=Comma delimited text file, B=tab delimted text file
                              ' D=PDF format file (must install WinPDF Converter), A=Ask the user.
                              ' The following 4 parameters are not used if the
                              ' device is set to 'P', 'F' ,'R', 'H', 'T', 'D', or 'C'.
       pad    As String * 3   ' to align the next integer item at 4 byte boundary

       x      As Long      ' Initial x position of the report window,
                              ' you may specify CW_USEDEFAULT to use default values.
       y      As Long      ' Initial y position of the report window.
       width  As Long      ' Initial width of the window in device units,
                              ' you may specify CW_USEDEFAULT to use default values.
       height As Long      ' Initial height of the editing window.  When you
                              ' use CW_USEDEFAULT for width, the height parameter is
                              ' ingnored.

       reserved1 As Long      ' Reserved for internal use.  Do not modify this field

       TotalFields As Long ' (OUTPUT) Number of fields in the 'field' array.

       reserved2 As Long      ' Reserved for internal use. Do not modify this field

       TotalSortFields As Long ' (OUTPUT) Number of fields in the 'SortField' array.

       DataSetName As String * 20 ' (OUTPUT) This field returns the data set name
                              ' associated with the form.  Your application
                              ' may use this information to prepare data for
                              ' the report executer
                              ' This field is NULL terminated

       SwapDir As String * 300 ' Directory path to store swapped screen pages
                              ' When this variable is equal to NULL, RE will use
                              ' the current working directory for swapping.
                              ' You must append chr(0) to NULL terminate this field

       hInst As Long       ' Handle of the current instanaces.
       hPrevInst As Long   ' Handle of the previous instances.
       hParentWnd As Long  ' Handle to the parent window
       style As Long          ' Report window style - needed for screen output only

       reserved3 As Long      ' Reserved for internal use. Do not modify the
                              ' value in this field

       SuppressPrintMessages As Long   'TRUE to suppress print time messages
       UseCurrentPrinter As Long   'TRUE to to use current printer instead of one from the form
       ReportId As Long            ' (OUTPUT) Report id assigned by RepInit function

       OutFile As String * 300   ' Output file name.  This field should
                                 ' specify a output file name when the device
                                 ' variable is set to 'F'.  If a file name
                                 ' is not specified, then this field should
                                 ' have a 0 in the first character position.
       TextPitch As Long         ' character picture for text output. Use 0 for default.
       ShowMenu As Long    ' show the toolbar
       ShowToolbar As Long ' show the toolbar
       DoPreprocessPass As Long  'a preprocess pass required for this report

       MasterDefFile As String * 300  ' master definition file
       DetailDefFile As String * 300  ' detail definition file
       OtherDefFiles As String * 1200 ' other definition files

       MasterDataFile As String * 300  ' master data file
       DetailDataFile As String * 300  ' detail data file
       OtherDataFiles As String * 1200 ' other data files

       PictFileName As String * 300    ' text file containing picture ids and picture names

       AutoRun As Long                  ' set to TRUE using the data files supplied in this structure

End Type

'*****************************************************************************
'   The parameter structure definition that is used by your application
'   to specify the operation parameters to view a report file.
'   For an example for using this structure, refer to the demo program.
'*****************************************************************************

Type TypeView
       file   As String * 300 ' formatted report file name
                              ' You must append chr(0) to NULL terminate this field

       device As String * 1   ' P=Printer,S=Screen, A=Ask the user.
                              ' The following 4 parameters are not used if the
                              ' device is set to 'P'
       pad    As String * 3   ' to align the next integer item at 4 byte boundary

       x      As Long      ' Initial x position of the report window,
                              ' you may specify CW_USEDEFAULT to use default values.
       y      As Long      ' Initial y position of the report window.
       width  As Long      ' Initial width of the window in device units,
                              ' you may specify CW_USEDEFAULT to use default values.
       height As Long      ' Initial height of the editing window.  When you
                              ' use CW_USEDEFAULT for width, the height parameter is
                              ' ingnored.

       SwapDir As String * 300 ' Directory path to store swapped screen pages
                              ' When this variable is equal to NULL, RE will use
                              ' the current working directory for swapping.
                              ' You must append chr(0) to NULL terminate this field

       hInst As Long       ' Handle of the current instanaces.
       hPrevInst As Long   ' Handle of the previous instances.
       hParentWnd As Long  ' Handle to the parent window
       style As Long          ' Report window style - needed for screen output only

       SuppressPrintMessages As Long   'TRUE to suppress print time messages
       ReportId As Long            ' (OUTPUT) Report id assigned by RepInit function
       TextPitch As Long         ' character picture for text output. Use 0 for default.
       ShowToolbar As Long ' show the toolbar
End Type

'*****************************************************************************
'                      Global Constants
'*****************************************************************************
Global Const FILE_RTF = 1
Global Const FILE_HTML = 2
Global Const FILE_TXT = 3
Global Const FILE_NATIVE = 4
Global Const FILE_PDF = 5

Global Const PDFFLAG_COMPRESS_TEXT = &H1
Global Const PDFFLAG_NO_BOOKMARK    =&H2     ' do not include bookmark
Global Const PDFFLAG_EMBED_FONTS    =&H4     ' always embed fonts
Global Const PDFFLAG_NO_HLINK       =&H8     ' do not include active hyperlink
Global Const PDFFLAG_BINARY_HINT    =&H10     ' write additional binary hit to satish yahoo and hotmail
Global Const PDFFLAG_EXACT_TEXT_PLACEMENT =&H20     ' place characters at exact positions
Global Const PDFFLAG_NO_CACHING     =&H40     ' write directly to disk file
Global Const PDFFLAG_DO_XPARENT     =&H80     ' support picture transparency
Global Const PDFFLAG_MULTI_DOC      =&H100     ' combining multiple TE documents to create one pdf doc
Global Const PDFFLAG_NO_PAGE_BM     =&H200     ' do not create page bitmap, page bitmap is needed to support transparency
Global Const PDFFLAG_NO_BOOKMARK_PANE =&H400     ' do not open the bookmark pane - only applicable when bookmarks are enabled
Global Const PDFFLAG_RC4_128          =&H800     ' use RC4-128 bit encryption when password is used
Global Const PDFFLAG_AES_128         =&H1000     ' use AES-128 bit encryption when password is used
Global Const PDFFLAG_RETURN_MSG_ID   =&H2000     ' sets the RFLAG_RETURN_MSG_ID flag
Global Const PDFFLAG_DONT_GET_WORLDTRANSFORM  =&H4000     ' use identity transform all the time
Global Const PDFFLAG_DONT_ROUND_IMAGE_DATA    =&H8000&    ' dont' round the image bits
Global Const PDFFLAG_PDFA_1B                 =&H10000     ' minimum compliance pdf/a-1b
Global Const PDFFLAG_PDFA                    =&H20000     ' minimum compliance pdf/a
Global Const PDFFLAG_SHOW_MISSING_SSZLIB_MSG =&H40000     ' show a message if sszlib not found
Global Const PDFFLAG_HPS                     =&H80000     ' called from html to pdf converter
Global Const PDFFLAG_CLEAR_BKND             =&H100000     ' clear page background 
Global Const PDFFLAG_TAGGED                 =&H200000     ' true to generated tagged pdf
Global Const PDFFLAG_NO_PAGE_SCALING        =&H400000     ' set the page scaling document property to None
Global Const PDFFLAG_DUPLEX_LONG            =&H800000     ' select duplex printing on the long edge
Global Const PDFFLAG_DUPLEX_SHORT          =&H1000000     ' select duplex printing on the short edge
Global Const PDFFLAG_PDFA3                 =&H2000000     ' minimum compliance pdf/a-3

Global Const REPFLAG_NO_PICT_PATH = &H1
Global Const REPFLAG_NO_OVERLAP_MSG = &H2

Global Const PERM_PRINT            =&H4     
Global Const PERM_MOD              =&H28
Global Const PERM_COPY             =&H10
Global Const PERM_PRINT_HI_RES    =&H800    


Global Const GROUP = &H0
Global Const label = &H10
Global Const field = &H20
Global Const section = &H40
Global Const PICT = &H80
Global Const LINE_OBJECT = &H100

Global Const RE_ITEM_TYPE_GROUP = &H0
Global Const RE_ITEM_TYPE_LABEL = &H10
Global Const RE_ITEM_TYPE_FIELD = &H20
Global Const RE_ITEM_TYPE_SECTION = &H40
Global Const RE_ITEM_TYPE_PICT = &H80
Global Const RE_ITEM_TYPE_LINE = &H100

Global Const MAX_REP_FIELDS = 500

Global Const UNITS_PER_INCH = 250

Global Const FORM_SIGN = &HDEBA&
Global Const NAME_WIDTH = 50

Global Const SRC_APPL = 0
Global Const SRC_CALC = 1
Global Const SRC_SYS = 2
Global Const SRC_CONST = 3
Global Const SRC_NONE = 4
Global Const SRC_DLG = 5

Global Const TYPE_NUM = 1
Global Const TYPE_DBL = 2
Global Const TYPE_TEXT = 3
Global Const TYPE_LOGICAL = 4
Global Const TYPE_DATE = 5
Global Const TYPE_PICT = 6

Global Const SUM_NONE = 0
Global Const SUM_TOTAL = 1
Global Const SUM_AVERAGE = 2
Global Const SUM_COUNT = 3
Global Const SUM_MAX = 4
Global Const SUM_MIN = 5
Global Const SUM_FTR_TOTAL = 6

Global Const DT_MMDDYY = 0
Global Const DT_DDMMYY = 1
Global Const DT_MMDDYYYY = 2
Global Const DT_MMMDDYYYY = 3
Global Const DT_YYYYMMDD = 4
Global Const DT_DDMMYYYY = 5

Global Const FLAG_TRIM = &H1
Global Const FLAG_SUP_ZERO = &H2
Global Const FLAG_PAD_ZERO = &H4
Global Const FLAG_CAPS = &H8
Global Const FLAG_FIRST_CAP = &H10
Global Const FLAG_SMALL = &H20
Global Const FLAG_COMMA = &H40
Global Const FLAG_WRAP = &H80
Global Const FLAG_WORD_WRAP = &H100
Global Const FLAG_RETAIN = &H200
Global Const FLAG_FLEX_SIZE = &H400
Global Const FLAG_NULL = &H4000
Global Const FLAG_SUP_TRAIL_ZERO = &H8000
Global Const FLAG_AUTOSIZE = &H10000
Global Const FLAG_KEEP_ASPECT = &H20000
Global Const FLAG_RESERVE_EMPTY_SPACE = &H40000
Global Const FLAG_SORT_DESCEND = &H80000
Global Const FLAG_DATE_ONLY = &H100000

Global Const FLAG1_DEF_STYLE = &H1
Global Const FLAG1_CALC_DONE = &H2
Global Const FLAG1_CURRENCY_AFTER = &H4
Global Const FLAG1_INVISIBLE = &H8

Global Const RFLAG_TRIAL = &H1
Global Const RFLAG_ALLOW_DESCEND_SORT = &H80
Global Const RFLAG_NO_CLEAR_SPL_HIST = &H100
Global Const RFLAG_ALT_NUM_DECIMAL = &H200
Global Const RFLAG_CENTER_DLGS_ON_SCR = &H400

Global Const REP_CLOSE = &H400

Global Const MAX_SECTIONS = 56
Global Const SEC_HDR_PAGE = 0
Global Const SEC_HDR_REP1 = 1
Global Const SEC_HDR_REP2 = 2
Global Const SEC_HDR_REP3 = 3
Global Const SEC_HDR_REP4 = 4
Global Const SEC_HDR_REP5 = 5
Global Const SEC_HDR_REP6 = 6
Global Const SEC_HDR_REP7 = 7
Global Const SEC_HDR_REP8 = 8
Global Const SEC_HDR_REP9 = 9
Global Const SEC_HDR_LVL1 = 10
Global Const SEC_HDR_LVL2 = 11
Global Const SEC_HDR_LVL3 = 12
Global Const SEC_HDR_LVL4 = 13
Global Const SEC_HDR_LVL5 = 14
Global Const SEC_HDR_LVL6 = 15
Global Const SEC_HDR_LVL7 = 16
Global Const SEC_HDR_LVL8 = 17
Global Const SEC_HDR_LVL9 = 18
Global Const SEC_DETAIL1 = 19
Global Const SEC_DETAIL2 = 20
Global Const SEC_DETAIL3 = 21
Global Const SEC_DETAIL4 = 22
Global Const SEC_DETAIL5 = 23
Global Const SEC_DETAIL6 = 24
Global Const SEC_DETAIL7 = 25
Global Const SEC_DETAIL8 = 26
Global Const SEC_DETAIL9 = 27
Global Const SEC_DETAIL10 = 28
Global Const SEC_DETAIL11 = 29
Global Const SEC_DETAIL12 = 30
Global Const SEC_DETAIL13 = 31
Global Const SEC_DETAIL14 = 32
Global Const SEC_DETAIL15 = 33
Global Const SEC_DETAIL16 = 34
Global Const SEC_DETAIL17 = 35
Global Const SEC_DETAIL18 = 36
Global Const SEC_FTR_LVL9 = 37
Global Const SEC_FTR_LVL8 = 38
Global Const SEC_FTR_LVL7 = 39
Global Const SEC_FTR_LVL6 = 40
Global Const SEC_FTR_LVL5 = 41
Global Const SEC_FTR_LVL4 = 42
Global Const SEC_FTR_LVL3 = 43
Global Const SEC_FTR_LVL2 = 44
Global Const SEC_FTR_LVL1 = 45
Global Const SEC_FTR_REP1 = 46
Global Const SEC_FTR_REP2 = 47
Global Const SEC_FTR_REP3 = 48
Global Const SEC_FTR_REP4 = 49
Global Const SEC_FTR_REP5 = 50
Global Const SEC_FTR_REP6 = 51
Global Const SEC_FTR_REP7 = 52
Global Const SEC_FTR_REP8 = 53
Global Const SEC_FTR_REP9 = 54
Global Const SEC_FTR_PAGE = 55

Global Const SFLAG_PAGE_BEF = &H1
Global Const SFLAG_PAGE_AFT = &H2
Global Const SFLAG_REPRINT = &H4
Global Const SFLAG_TRIM_BEFORE = &H8
Global Const SFLAG_TRIM_AFTER = &H10
Global Const SFLAG_RESET_PAGE_NO = &H20
Global Const SFLAG_KEEP_WITH_NEXT = &H40
Global Const SFLAG_RESET_HEIGHT = &H80
Global Const SFLAG_KEEP = &H100
Global Const SFLAG_VAR_HEIGHT = &H200

Global Const OFLAG_FILL = &H2
Global Const OFLAG_HLEFT = &H4
Global Const OFLAG_HRIGHT = &H8
Global Const OFLAG_HCENTER = &H10
Global Const OFLAG_VTOP = &H20
Global Const OFLAG_VCENTER = &H40
Global Const OFLAG_VBOTTOM = &H80
Global Const OFLAG_SELECT_TOGGLE = &H100
Global Const OFLAG_MULTILINE = &H200
Global Const OFLAG_VERT = &H400
Global Const OFLAG_INVISIBLE = &H800
Global Const OFLAG_DEF_STYLE = &H1000
Global Const OFLAG_MARKED = &H2000
Global Const OFLAG_HLINK = &H4000
Global Const OFLAG_CUR_ITEM = &H8000

Global Const OUTLINE_LEFT = &H1
Global Const OUTLINE_RIGHT = &H2
Global Const OUTLINE_TOP = &H4
Global Const OUTLINE_BOT = &H8


Global Const ERR_NO_FILE = 1
Global Const ERR_NO_DEVICE = 2
Global Const ERR_NO_MEM = 3
Global Const ERR_BAD_EXP = 4
Global Const ERR_SUSPEND = 5
Global Const ERR_ZERO_DIVIDE = 6
Global Const ERR_TYPE_MISMATCH = 7
Global Const ERR_INCOMPLETE = 8
Global Const ERR_DUPLICATE = 9
Global Const ERR_PRINTER = 10
Global Const ERR_IO = 11
Global Const ERR_DISPLAY = 12
Global Const ERR_WRAP = 13
Global Const ERR_FONT = 14
Global Const ERR_OTHER = 15

Global Const ERR_BAD_WND = 16
Global Const ERR_NO_REP_ID = 17
Global Const ERR_BAD_REP_ID = 18
Global Const ERR_NO_OUTFILE = 19


Global Const WS_OVERLAPPEDWINDOW = &HCF0000
Global Const WS_CHILD = &H40000000
Global Const MF_ENABLED = 0
Global Const MF_GRAYED = 1
Global Const MF_CHECKED = 8
Global Const MF_UNCHECKED = 0

Global Const ACTION_COMMAND = 1
Global Const ACTION_VSCROLL = 2
Global Const ACTION_HSCROLL = 3
Global Const ACTION_LBUTTONDOWN = 5
Global Const ACTION_RBUTTONDOWN = 6
Global Const ACTION_LBUTTONUP = 7
Global Const ACTION_RBUTTONUP = 8
Global Const ACTION_LBUTTONDBLCLK = 9
Global Const ACTION_RBUTTONDBLCLK = 10
Global Const ACTION_SIZE = 11
Global Const ACTION_SETFOCUS = 12
Global Const ACTION_KILLFOCUS = 13
Global Const ACTION_MOUSEMOVE = 14

Global Const REP_BOLD = &H1
Global Const REP_ULINE = &H2
Global Const REP_ITALIC = &H4
Global Const REP_STRIKE = &H8

'******************************************************************************
'                       Form Header Structure
'******************************************************************************
Type TypeFormHdr
       FormSign As Long       ' Form File Signature

       name As String * 52       ' report name (NAME_WIDTH+2)
                                       ' This field is NULL terminated

       DataSetName As String * 20 ' Your application can specify a data set
                                 ' name which can be used to associate the
                                 ' application data to the form.  This
                                 ' is an optional information.
                                 ' This field is NULL terminated

       TotalItems As Long     ' screen items in the form template
       FieldCount As Long     ' total number of fields
       BreakFieldCount As Long ' total number of break fields
       FontCount As Long      ' number of entries in the font table

       LeftMargin As Single      ' margins in inches
       RightMargin As Single
       TopMargin As Single
       BottomMargin As Single

       SelExp As String * 208    ' record selection expression 2*(NAME_WIDTH+2)

       Orientation As Long    ' DMORIENT_PORTRAIT or DMORIENT_LANDSCAPE
       PaperSize As Long      ' paper size given by DMPAPER_* variables used for DEVMODE
       PaperLength As Long    ' specified in tenths of millimeter, used only if PaperSize = 0
       PaperWidth As Long     ' specified in tenths of millimeter, used only if PaperSize = 0
       PrintQuality As Long   ' print quality

       OldPrinterName As String * 52 ' not used anylonger
       OldPrinterDriver As String * 52 ' not used any longer

       flags As Long          ' RFLAG_ series flags

       DateFormat As Long     ' 0=MM/DD/YY, 1=DD/MM/YY

       RulerType As Long      ' RULER_OFF,RULER_INCH,RULER_CM

       SecBannerHeight As Long ' height (logical units) of the section banner
       FileFormatId As Long    ' records the file format changes

       PrinterName As String * 302 ' name of the printer 2*(MAX_WIDTH+2)
       PrinterDriver As String * 302 ' printer driver name 2*(MAX_WIDTH+2)

       CustColors As String * 64 ' 20091002: to store 16 COLORREF values
       
       reserved1 As String * 78  ' reserved bytes
End Type

'******************************************************************************
'                        Field Structure
'******************************************************************************
Type TypeField                    ' define each field
       source As Long        ' source of field data: application,calculation,system, constant etc

       reserved3 As String * 52 ' reserved

       FileId As Long        ' an optional id that may be defined by the calling application
       FieldId As Long       ' another optional id that may be defined by the calling application
       type As Long          ' numeric/alphanumeric/logical/date
       width As Long         ' field data width as stored in your database
       DecPlaces As Long     ' decimal places for numeric fields
       AllowChanges As Long  ' Allow modification of the following fields

       InUse As Long         ' TRUE=in use, FALSE=not in use
       flags As Long         ' flags
       SumType As Long       ' summary type: total/average/minmum/maximum/none
       SysIdx As Long        ' index into the system field table for system fields

       DateFormat As Long    ' date format
       DateDelim As String * 2  ' date delimiter character, i.e. / or -

       CurrencySymbol As String * 4 ' currency symbol
       LogicalSymbols As String * 2 ' logical TRUE and FALSE symbols

       NegSignPrefix As String * 4 ' negative sign prefix
       NegSignSuffix As String * 4 ' negative sign suffix
       PosSignPrefix As String * 4 ' positive sign prefix
       PosSignSuffix As String * 4 ' positive sign suffix

       CalcExp As String * 208  ' expression for the calculated fields 2*(NAME_WIDTH+2)

       reserved1 As Long        ' character data, pointer to an object of size = field.width+1
       NumData As Long          ' numeric data (long)
       DblData As Double        ' numeric data for field = TYPE_DBL

       HoldNum As Long          ' long accumulater: total,minimum,maximum,etc...
       HoldDbl As Double        ' double accumulater: total,minimum,maximum,etc...
       count As Long            ' number of records in a group during execution

       section As Long          ' section that holds the field (report time only)
       misc As Long             ' used for miscellaneous purposes

       ParaChar As String * 2   ' specify the new paragraph indicator character
                                ' in the first byte.  Needed only for a word/wrapped
                                ' text field.
                                ' You must append chr(0) to NULL terminate this field
       reserved2 As String * 10  ' not used in vb
       flags1 As Long           ' FLAG1_ constant
       name As String * 102     ' field name (2*NAME_WIDTH+2)
                                ' Append chr (0) to NULL terminate this field
End Type

'******************************************************************************
'                        Picture information structure
'******************************************************************************
Type TypePict
      hDC     As Long        ' Device Context of the report output device
      PictId  As Long        ' picture id value
      FileId  As Long        ' FileId of the picture
      FieldId As Long        ' FieldId of the picture
      x       As Long        ' picture location
      y       As Long        ' picture location
      width   As Long        ' picture width
      height  As Long        ' picture height
      flags   As Long        ' picture field flags
      pRect   As Long        'pointer to the picture rectangle painted
End Type

Type TypeRvdPict
      hDC     As Long        ' Device Context of the report output device
      PictId  As Long        ' picture id value
      FileId  As Long        ' FileId of the picture
      FieldId As Long        ' FieldId of the picture
      x       As Long        ' picture location
      y       As Long        ' picture location
      width   As Long        ' picture width
      height  As Long        ' picture height
      flags   As Long        ' picture field flags
      pRect   As Long        'pointer to the picture rectangle painted
End Type

Rem *****************************************************************************
Rem                    Command Ids
Rem ******************************************************************************
Global Const ID_FIRST = 600
Global Const ID_PGUP = 600
Global Const ID_PGDN = 601
Global Const ID_UP = 602
Global Const ID_DOWN = 603
Global Const ID_LEFT = 604
Global Const ID_RIGHT = 605
Global Const ID_INSERT_LABEL = 606
Global Const ID_REN_FONT_EXP = 607
Global Const ID_MOVE_ITEM = 608
Global Const ID_SIZE_ITEM = 609
Global Const ID_CENTER_ITEM = 610
Global Const ID_SELECT_MULTIPLE = 611
Global Const ID_EDIT_LABEL = 612

Global Const ID_PRINT = 613
Global Const ID_PREVIEW = 614
Global Const ID_EXIT = 615

Global Const ID_REN_CALC_FLD = 616


Global Const ID_ADD_FONT_EXP = 617
Global Const ID_MOD_FONT_EXP = 618
Global Const ID_DEL_FONT_EXP = 619


Global Const ID_PICT_FROM_CB = 620
Global Const ID_PICT_FROM_FILE = 621
Global Const ID_HELP = 622
Global Const ID_JUMP = 623
Global Const ID_SAVE = 624
Global Const ID_SAVEAS = 625
Global Const ID_QUIT = 626
Global Const ID_REP_PARAM = 628
Global Const ID_REP_FILTER = 629
Global Const ID_PRINT_OPTIONS = 630

Global Const ID_ITEM_FONT_EXP = 631
Global Const ID_DEF_STYLE_ITEM = 632
Global Const ID_DEF_STYLE_FIELD = 633
Global Const ID_APPLY_DEF_ITEM_STYLE = 634
Global Const ID_APPLY_DEF_FIELD_STYLE = 635
Global Const ID_SEC_DEL = 636

Global Const ID_ERASE_CB = 637

Global Const ID_FONTS = 638

Global Const ID_EDIT_FLD = 639
Global Const ID_EDIT_FLD_EXP = 640

Global Const ID_INSERT_DATA = 641
Global Const ID_INSERT_CALC = 642
Global Const ID_INSERT_SYS = 643
Global Const ID_INSERT_DLG = 644

Global Const ID_SEC_NEW = 645
Global Const ID_SEC_EDIT = 646

Global Const ID_SEC_FILTER = 648
Global Const ID_SEC_SORT = 649
Global Const ID_SEC_BREAK = 650

Global Const ID_DLG_CREATE = 651
Global Const ID_DLG_MODIFY = 652
Global Const ID_DLG_DELETE = 653

Global Const ID_PAGE_TOP = 654
Global Const ID_PAGE_BOT = 655

Global Const ID_SHOW_BOUNDERS = 656
Global Const ID_SHOW_FIELD_NAMES = 657
Global Const ID_LCASE_FIELD_NAMES = 658
Global Const ID_SPELL = 659

Global Const ID_INSERT_LINE = 660
Global Const ID_ITEM_OUTLINE = 661
Global Const ID_ITEM_BACKGROUND = 662
Global Const ID_POS_ITEM = 663
Global Const ID_DEL_ITEM = 664
Global Const ID_UNDO = 665
Global Const ID_EDIT_LINE = 666

Global Const ID_NEXT_PAGE = 667
Global Const ID_PREV_PAGE = 668
Global Const ID_FIRST_PAGE = 669
Global Const ID_LAST_PAGE = 670

Global Const ID_EDIT_LABEL_FMT = 671

Global Const ID_ADD_FONT_NAME = 672
Global Const ID_MOD_FONT_NAME = 673
Global Const ID_DEL_FONT_NAME = 674

Global Const ID_ALIGN_HORZ_TOP = 675
Global Const ID_ALIGN_HORZ_BOT = 676
Global Const ID_ALIGN_HORZ_CENTER = 677
Global Const ID_ALIGN_VERT_LEFT = 678
Global Const ID_ALIGN_VERT_RIGHT = 679
Global Const ID_ALIGN_VERT_CENTER = 680

Global Const ID_EVEN_SIZE_HORZ = 681
Global Const ID_EVEN_SIZE_VERT = 682

Global Const ID_EVEN_SPACE_HORZ = 683
Global Const ID_EVEN_SPACE_VERT = 684

Global Const ID_DESC_WND = 685
Global Const ID_CUT = 686
Global Const ID_COPY = 687
Global Const ID_PASTE = 688
Global Const ID_SNAP_TO_GRID = 689

Global Const ID_EXPAND_HORZ = 690
Global Const ID_EXPAND_VERT = 691
Global Const ID_COMPRESS_HORZ = 692
Global Const ID_COMPRESS_VERT = 693

Global Const ID_BOLD_ON = 694
Global Const ID_ULINE_ON = 695
Global Const ID_ITALIC_ON = 696
Global Const ID_CENTER = 697
Global Const ID_RIGHT_JUSTIFY = 698
Global Const ID_JUSTIFY = 699
Global Const ID_LEFT_JUSTIFY = 700
Global Const ID_INSERT_DATE_TIME = 701
Global Const ID_INSERT_PAGE_NUMBER = 702
Global Const ID_INSERT_PAGE_COUNT = 703

Global Const ID_NEW = 704
Global Const ID_OPEN = 705
Global Const ID_TOP_JUSTIFY = 706
Global Const ID_BOT_JUSTIFY = 707
Global Const ID_TEXT_COLOR = 708
Global Const ID_FILL_COLOR = 709
Global Const ID_BORDER_COLOR = 710


Rem *****************************************************************************
Rem                    Function Prototype
Rem ******************************************************************************
Declare Function RvbForm Lib "ROC8.OCX" (ByVal pCtl As Long, FormParm As TypeForm) As Long
Declare Function RvbInit Lib "ROC8.OCX" (ByVal pCtl As Long, RepParm As TypeRep) As Long
Declare Function RvbRec Lib "ROC8.OCX" (ByVal pCtl As Long) As Long
Declare Function RvbExit Lib "ROC8.OCX" (ByVal pCtl As Long) As Long
Declare Function RvbView Lib "ROC8.OCX" (ByVal pCtl As Long, ViewParm As TypeView) As Long

Declare Function RvbGetFormField Lib "ROC8.OCX" (ByVal pCtl As Long, field As TypeField, SortLevel As Long) As Long
Declare Function RvbGetDataField Lib "ROC8.OCX" (ByVal pCtl As Long, ByVal FieldNo As Long, field As TypeField) As Long
Declare Function RvbSetDataField Lib "ROC8.OCX" (ByVal pCtl As Long, ByVal FieldNo As Long, field As TypeField) As Long
Declare Function RvbGetDataFieldInfo Lib "ROC8.OCX" (ByVal pCtl As Long, ByVal FieldNo As Long, FieldSource As Long, FieldType As Long, FileId As Long, FieldId As Long, FieldName As Any) As Long
Declare Function RvbGetSortField Lib "ROC8.OCX" (ByVal pCtl As Long, ByVal FieldNo As Long, field As TypeField) As Long
Declare Function RvbSetFormField Lib "ROC8.OCX" (ByVal pCtl As Long, field As TypeField, ByVal valid As Long) As Long

Declare Function RvbSetTextField Lib "ROC8.OCX" (ByVal pCtl As Long, ByVal FieldNo As Long, ByVal TextData As String, ByVal TextDataLen As Long) As Long
Declare Function RvbSetNumField Lib "ROC8.OCX" (ByVal pCtl As Long, ByVal FieldNo As Long, ByVal NumData As Long) As Long
Declare Function RvbSetDoubleField Lib "ROC8.OCX" (ByVal pCtl As Long, ByVal FieldNo As Long, ByVal DoubleData As Double) As Long

Declare Function RvbGetPictureInfo Lib "ROC8.OCX" (ByVal pCtl As Long, PictInfo As TypePict) As Long
Declare Function RvbDrawBitmap Lib "ROC8.OCX" (ByVal pCtl As Long, ByVal pWnd As Long, ByVal hBM As Long, ByVal PictX As Long, ByVal PictY As Long, ByVal PictWidth As Long, ByVal PictHeight As Long) As Long
Declare Function RvbEnableFormWindow Lib "ROC8.OCX" (ByVal pCtl As Long, ByVal enable As Long) As Long

Declare Function RepDrawTerText Lib "REP8.DLL" (ByVal ReportId As Long, ByVal RtfFile As String, ByVal hRtfBuf As Long, ByVal BufLen As Long, FieldNames As Any, FieldValues As Any) As Integer
Declare Function RepInsertSection Lib "REP8.DLL" (ByVal hWnd As Long, ByVal SecId As Long, ByVal SortFieldName As String) As Long

Declare Function RepListInit Lib "REP8.DLL" (ByVal hWnd As Long, ByVal ListTitle As String, ByVal ListX As Long, ByVal ListY As Long) As Long
Declare Function RepListAppend Lib "REP8.DLL" (ByVal hWnd As Long, ByVal ItemDesc As String) As Long
Declare Function RepListShow Lib "REP8.DLL" (ByVal hWnd As Long) As Long

Declare Function RepCommand Lib "REP8.DLL" (ByVal hWnd As Long, ByVal CmdId As Long) As Long
Declare Function RepCommand2 Lib "REP8.DLL" (ByVal hWnd As Long, ByVal CmdId As Long, ByVal send As Long) As Long
Declare Function RepMenuEnable Lib "REP8.DLL" (ByVal hWnd As Long, ByVal CmdId As Long) As Long
Declare Function RepMenuSelect Lib "REP8.DLL" (ByVal hWnd As Long, ByVal CmdId As Long) As Long
Declare Function RepModified Lib "REP8.DLL" (ByVal hWnd As Long) As Long
Declare Function RepSetModify Lib "REP8.DLL" (ByVal hWnd As Long, ByVal modified As Long) As Long
Declare Function RepQueryExit Lib "REP8.DLL" (ByVal hWnd As Long) As Long
Declare Function RepIgnoreCommand Lib "REP8.DLL" (ByVal hWnd As Long) As Long
Declare Function RepGetItemInfo Lib "REP8.DLL" (ByVal hWnd As Long, ByVal CurItem As Long, ByVal label As String, x As Long, y As Long, ItemWidth As Long, ItemHeight As Long, ItemType As Long, AuxId As Long, FieldType As Long) As Long
Declare Function RepGetPageInfo Lib "REP8.DLL" (ByVal hWnd As Long, CurPage As Long, TotalPages As Long, RecCount As Long) As Long
Declare Function RepDebugMsg Lib "REP8.DLL" (ByVal msg As String) As Long
Declare Function RepSetDefPrinter Lib "REP8.DLL" (ByVal PrtName As String, ByVal PrtDriver As String, ByVal PrtPort As String) As Long
Declare Function RepSaveReport Lib "REP8.DLL" (ByVal hWnd As Long, ByVal OutFormat As Long, ByVal FileName As String) As Long
Declare Function RepSetRtfAttach Lib "REP8.DLL" (ByVal RepId As Long, ByVal FileName As String, ByVal before As Long, ByVal FieldName As String, ByVal FieldData As String) As Long
Declare Function RepGetField Lib "REP8.DLL" (ByVal hWnd As Long, ByVal ReportId As Long, ByVal FieldNo As Long, field As TypeField) As Long
Declare Function RepSetField Lib "REP8.DLL" (ByVal hWnd As Long, ByVal ReportId As Long, ByVal FieldNo As Long, field As TypeField) As Long
Declare Function RepSetHdrPos Lib "REP8.DLL" (ByVal ReportHdrBefPageHdr As Long) As Long
Declare Function RepAllowPageCountField Lib "REP8.DLL" (ByVal allow As Long) As Long
Declare Function RepBeginPreprocessPass Lib "REP8.DLL" (ByVal RepId As Long) As Long
Declare Function RepEndPreprocessPass Lib "REP8.DLL" (ByVal RepId As Long) As Long

Declare Function RepCanInsertSect Lib "REP8.DLL" (ByVal SectId As Long, ByVal allow As Long) As Long
Declare Function RepShrinkWrapFieldSpace Lib "REP8.DLL" (ByVal shrink As Long) As Long
Declare Function RepSetPrinter Lib "REP8.DLL" (ByVal hWnd As Long, ByVal PrintSetup As Long, ByVal RepFile As String, ByVal persists As Long) As Long

Declare Function RepSetItemFont Lib "REP8.DLL" (ByVal hWnd As Long, ByVal ItemId As Long, ByVal typeface As String, ByVal PointSize As Long, ByVal style As Long, ByVal color As Long, ByVal repaint As Long) As Long

Declare Function RepSetDefPrinterFlag Lib "REP8.DLL" (ByVal UseDefaultPrinter As Long) As Long

Declare Function RepPrintFromPreview Lib "REP8.DLL" (ByVal hWnd As Long, ByVal PrtName As String, ByVal PrtDriver As String, ByVal PrtPort As String, ByVal FirstPage As Long, ByVal LastPage As Long) As Long

Declare Function RepInsertSection2 Lib "REP8.DLL" (ByVal hWnd As Long, ByVal SecId As Long, ByVal SortFieldName As String, ByVal height As Long, ByVal columns As Long, ByVal flags As Long, ByVal repaint As Long) As Long
Declare Function RepInsertField Lib "REP8.DLL" (ByVal hWnd As Long, ByVal FldType As Long, ByVal FieldName As String, ByVal InSect As Long, ByVal x As Long, ByVal y As Long, ByVal FldWidth As Long, ByVal height As Long, ByVal repaint As Long) As Long
Declare Function RepInsertField2 Lib "REP8.DLL" (ByVal hWnd As Long, ByVal FldType As Long, ByVal FieldName As String, ByVal InSect As Long, ByVal x As Long, ByVal y As Long, ByVal FldWidth As Long, ByVal height As Long, ByVal formula As String, ByVal repaint As Long) As Long
Declare Function RepDeleteSection Lib "REP8.DLL" (ByVal hWnd As Long, ByVal SecId As Long) As Long
Declare Function RepSetFlags Lib "REP8.DLL" (ByVal hWnd As Long, ByVal RepId As Long, ByVal SetReset As Long, ByVal flags As Long) As Long
Declare Function RepSetItemInfo Lib "REP8.DLL" (ByVal hWnd As Long, ByVal CurItem As Long, ByVal TextColor As Long, ByVal BackColor As Long, ByVal border As Long, ByVal BorderType As Long, ByVal BorderThickness As Long, ByVal BorderColor As Long, ByVal repaint As Long) As Long
Declare Function RepSetRtfAttach2 Lib "REP8.DLL" (ByVal RepId As Long, ByVal FileName As String, ByVal before As Long, ByVal FieldName As String, ByVal FieldData As String, ByVal continuous As Long) As Long

Declare Function RepIsPrinting Lib "REP8.DLL" (ByVal RepId As Long) As Long
Declare Function RepGetCurPrinter Lib "REP8.DLL" (ByVal PrtName As String) As Long
Declare Function RepRenameField Lib "REP8.DLL" (ByVal hWnd As Long, ByVal PrevName As String, ByVal NewName As String, ByVal NewFileId As Long, ByVal NewFieldId As Long) As Long

Declare Function RepPdfSetDllName Lib "REP8.DLL" (ByVal DllName As String) As Long

Declare Function RepGetSelectedPrinter Lib "REP8.DLL" (ByVal hWnd As Long, ByVal RepId As Long, ByVal PrtName As String) As Long
Declare Function RepSetLicenseKey Lib "REP8.DLL" (ByVal LicKey As String) As Long
Declare Function RepSetItemFont2 Lib "REP8.DLL" (ByVal hWnd As Long, ByVal ItemId As Long, ByVal typeface As String, ByVal PointSize As Long, ByVal style As Long, ByVal color As Long, ByVal CharSet As Long, ByVal repaint As Long) As Long
Declare Function RepSetCharSet Lib "REP8.DLL" (ByVal hWnd As Long, ByVal CharSet As Long) As Long

Declare Function RepLastPrinterSelectionResult Lib "REP8.DLL" (ByVal hWnd As Long) As Long
Declare Function RepImportCustomColors Lib "REP8.DLL" (ByVal hWnd As Long, ByVal RepFile As String) As Long

Declare Function RvdInit Lib "REP8.DLL" (RepParm As TypeRep, ByVal DrawPictCallback As Long) As Long
Declare Function RvdRec Lib "REP8.DLL" (ByVal ReportId As Long) As Long
Declare Function RvdExit Lib "REP8.DLL" (ByVal ReportId As Long) As Long
Declare Function RvdGetSortField Lib "REP8.DLL" (ByVal ReportId As Long, ByVal FieldNo As Long, field As TypeField) As Long
Declare Function RvdGetDataField Lib "REP8.DLL" (ByVal ReportId As Long, ByVal FieldNo As Long, field As TypeField) As Long
Declare Function RvdSetDataField Lib "REP8.DLL" (ByVal ReportId As Long, ByVal FieldNo As Long, field As TypeField) As Long
Declare Function RvdSetTextField Lib "REP8.DLL" (ByVal ReportId As Long, ByVal FieldNo As Long, ByVal TextData As String, ByVal TextDataLen As Long) As Long
Declare Function RvdSetNumField Lib "REP8.DLL" (ByVal ReportId As Long, ByVal FieldNo As Long, ByVal NumData As Long) As Long
Declare Function RvdSetDoubleField Lib "REP8.DLL" (ByVal ReportId As Long, ByVal FieldNo As Long, ByVal DoubleData As Double) As Long

Declare Function RvdGetPictureInfo Lib "REP8.DLL" (ByVal ReportId As Long, PictInfo As TypeRvdPict) As Long
Declare Function RvdDrawBitmap Lib "REP8.DLL" (ByVal ReportId As Long, ByVal hWnd As Long, ByVal hBM As Long, ByVal PictX As Long, ByVal PictY As Long, ByVal PictWidth As Long, ByVal PictHeight As Long) As Long

Declare Function RvdPictureListAdd Lib "REP8.DLL" (ByVal ReportId As Long, ByVal PictKey As String, ByVal PictTag As String, ByVal hBitmap As Long) As Long
Declare Function RvdPictureListRemove Lib "REP8.DLL" (ByVal ReportId As Long, ByVal PictKey As String) As Long
Declare Function RvdPictureListReplace Lib "REP8.DLL" (ByVal ReportId As Long, ByVal PictKey As String, ByVal PictTag As String, ByVal hBitmap As Long) As Long
Declare Function RvdPictureListGet Lib "REP8.DLL" (ByVal ReportId As Long, ByVal PictKey As String) As Long
Declare Function RvdPictureListGetTag Lib "REP8.DLL" (ByVal ReportId As Long, ByVal PictKey As String, ByVal PictTag As String) As Long
Declare Function RvdPictureListExists Lib "REP8.DLL" (ByVal ReportId As Long, ByVal PictKey As String) As Long
Declare Function RvdPictureListRemoveAll Lib "REP8.DLL" (ByVal ReportId As Long) As Long
Declare Function RvdPictureListAddFromFile Lib "REP8.DLL" (ByVal ReportId As Long, ByVal PictKey As String, ByVal PictTag As String, ByVal FileName As String) As Long
Declare Function RvdPictureListReplaceFromFile Lib "REP8.DLL" (ByVal ReportId As Long, ByVal PictKey As String, ByVal PictTag As String, ByVal FileName As String) As Long

Declare Function RvdSetProgressCallback Lib "REP8.DLL" (ByVal ReportId As Long, ByVal PrintProgressCallback as long) As Long


Rem **************************************************
Rem When a string is passed for OUTPUT to the DLL
Rem ,the output string created by the DLL has an extra
Rem NULL character.  For such strings, you must call
Rem this routine to strip the null character from the
Rem given string
Rem **************************************************
Function DiscardNull(InText As String) As String
    Dim NullPos As Long

    NullPos = InStr(InText, Chr(0))
    If NullPos = 0 Then
      'No Null Characters were found in the string.
      DiscardNull = InText
    Else
      DiscardNull = Left(InText, NullPos - 1)
    End If

End Function

